# The mandatory variable to be passed to the module. This is intended as a standard across all the modules.

variable "context" {
  type = object({
    cost_center = string
    project_code = string
    region = string
    env_name = string
    zone = string
    tier = string
  })

  description = <<EOF
    (Required)  Map of mandatory parameters that have to be passed to every terraform module that you create. The value is an object with the following attributes:
    - cost_center: (Required) The Cost Center Code.
    - project_code: (Required) The Project code.
    - region: (Required) AWS region.
    - env_name: (Required) Environment name.
    - zone: (Required) The zone where the resource will be created. Typical values are : ez|iz|mgmt
    - tier: (Required) The tier where the resource will be created. Typical values are : web|gut|app|it|db|vpcendpoint|mgmt

    ```
      eg: {
        "cost_center": "b-0001",
        "project_code": "xyz",
        "region": "us-east-1",
        "env_name": "dev",
        "zone": "ez",
        "tier": "web"
      }
    ```
  EOF

  # validate agency code must not be empty
  validation {
    condition     = length(var.context.cost_center) > 0
    error_message = "The cost_center must not be empty."
  }

  # validate project code must not be empty
  validation {
    condition     = length(var.context.project_code) > 0
    error_message = "The project_code must not be empty."
  }

  # validate region must not be empty
  validation {
    condition     = length(var.context.region) > 0
    error_message = "The region must not be empty."
  }

  # validate env_name must not be empty
  validation {
    condition     = length(var.context.env_name) > 0
    error_message = "The env_name must not be empty."
  }
  
  # validate zone must not be empty
  validation {
    condition     = length(var.context.zone) > 0
    error_message = "The zone must not be empty."
  }

  # validate tier must not be empty
  validation {
    condition     = length(var.context.tier) > 0
    error_message = "The tier must not be empty."
  }
}


variable "additional_tags" {
    type = map(string)
    default = {}
    description = <<EOT
    (Optional) These are the additional tags that are provided by the user. The values provided in the tags will *override* the tags generated by the module. 

    eg: 
    additional_tags : {
        "foo" ="bar"
    }

    The Name has the potential to override the 'Name' formed by the module. 
    Ideally, the additional tags should be used to pass non standard tags eg 'foo', etc
    EOT

}